#include <stdio.h>
#include "files.h"
#include "new.h"

extern char dflag;
extern char vflag;
extern char *mktemp();

char *action_file_name = ACTION_FILE;
char *defines_file_name = DEFINES_FILE;
char *input_file_name;
char *parser_file_name = PARSER_FILE;
char *output_file_name = OUTPUT_FILE;
char *temp_file_name = TEMP_FILE;
char *verbose_file_name = VERBOSE_FILE;

FILE *action_file = NULL;
FILE *defines_file = NULL;
FILE *input_file = NULL;
FILE *parser_file = NULL;
FILE *output_file = NULL;
FILE *temp_file = NULL;
FILE *verbose_file = NULL;


openfiles()
{
  (void) mktemp(action_file_name);
  (void) mktemp(temp_file_name);

  input_file = fopen(input_file_name, "r");
  if (input_file == NULL) open_error(input_file_name);

  parser_file = fopen(parser_file_name, "r");
  if (parser_file == NULL) open_error(parser_file_name);

  action_file = fopen(action_file_name, "w");
  if (action_file == NULL) open_error(action_file_name);

  if (vflag)
    {
      verbose_file = fopen(verbose_file_name, "w");
      if (verbose_file == NULL) open_error(verbose_file_name);
    }

  if (dflag)
    {
      defines_file = fopen(defines_file_name, "r");
      if (defines_file == NULL)
	{
	  defines_file = fopen(defines_file_name, "w");
	  if (defines_file == NULL) open_error(defines_file_name);
	  temp_file = defines_file;
	}
      else
	{
	  temp_file = fopen(temp_file_name, "w");
	  if (temp_file == NULL) temp_file = defines_file;
	}
    }

  output_file = fopen(output_file_name, "w");
  if (output_file == NULL) open_error(output_file_name);
}

tidy()
{
  if (action_file != NULL)
    {
      ZAPFILE(action_file_name);
      (void) fclose(action_file);
    }

  if (dflag)
    {
      if (defines_file != NULL)
	{
	  if (defines_file == temp_file)
	    {
	      (void) fclose(defines_file);
	      temp_file = NULL;
	    }
	}
      if (temp_file != NULL)
	{
	  ZAPFILE(temp_file_name);
	  (void) fclose(temp_file);
	}
    }

  if (vflag && verbose_file != NULL) (void) fclose(verbose_file);
  if (input_file != NULL) (void) fclose(input_file);
  if (parser_file != NULL) (void) fclose(parser_file);
  if (output_file != NULL) (void) fclose(output_file);
}
